## dpdk 24.11.3

=== meson_options.txt ===
# Please keep these options sorted alphabetically.

option('check_includes', type: 'boolean', value: false, description:
       'build "chkincs" to verify each header file can compile alone')
option('cpu_instruction_set', type: 'string', value: 'auto',
	description: 'Set the target machine ISA (instruction set architecture). Will be set according to the platform option by default.')
option('developer_mode', type: 'feature', description:
       'turn on additional build checks relevant for DPDK developers')
option('disable_apps', type: 'string', value: '', description:
       'Comma-separated list of apps to explicitly disable.')
option('disable_drivers', type: 'string', value: '', description:
       'Comma-separated list of drivers to explicitly disable.')
option('disable_libs', type: 'string', value: '', description:
       'Comma-separated list of optional libraries to explicitly disable. [NOTE: mandatory libs cannot be disabled]')
option('drivers_install_subdir', type: 'string', value: 'dpdk/pmds-<VERSION>', description:
       'Subdirectory of libdir where to install PMDs. Defaults to using a versioned subdirectory.')
option('enable_docs', type: 'boolean', value: false, description:
       'build documentation')
option('enable_apps', type: 'string', value: '', description:
       'Comma-separated list of apps to build. If unspecified, build all apps.')
option('enable_deprecated_libs', type: 'string', value: '', description:
       'Comma-separated list of deprecated libraries to explicitly enable.')
option('enable_drivers', type: 'string', value: '', description:
       'Comma-separated list of drivers to build. If unspecified, build all drivers.')
option('enable_driver_sdk', type: 'boolean', value: false, description:
       'Install headers to build drivers.')
option('enable_kmods', type: 'boolean', value: true, description:
       '[Deprecated - will be removed in future release] build kernel modules')
option('enable_libs', type: 'string', value: '', description:
       'Comma-separated list of optional libraries to explicitly enable. [NOTE: mandatory libs are always enabled]')
option('examples', type: 'string', value: '', description:
       'Comma-separated list of examples to build by default')
option('ibverbs_link', type: 'combo', choices : ['static', 'shared', 'dlopen'], value: 'shared', description:
       'Linkage method (static/shared/dlopen) for NVIDIA PMDs with ibverbs dependencies.')
option('include_subdir_arch', type: 'string', value: '', description:
       'subdirectory where to install arch-dependent headers')
option('kernel_dir', type: 'string', value: '', description:
       'Path to the kernel for building kernel modules. Headers must be in $kernel_dir or $kernel_dir/build. Modules will be installed in /lib/modules.')
option('machine', type: 'string', value: 'auto', description:
       'Alias of cpu_instruction_set.')
option('max_ethports', type: 'integer', value: 32, description:
       'maximum number of Ethernet devices')
option('max_lcores', type: 'string', value: 'default', description:
       'Set maximum number of cores/threads supported by EAL; "default" is different per-arch, "detect" detects the number of cores on the build machine.')
option('max_numa_nodes', type: 'string', value: 'default', description:
       'Set the highest NUMA node supported by EAL; "default" is different per-arch, "detect" detects the highest NUMA node on the build machine.')
option('enable_iova_as_pa', type: 'boolean', value: true, description:
       'Support the use of physical addresses for IO addresses, such as used by UIO or VFIO in no-IOMMU mode. When disabled, DPDK can only run with IOMMU support for address mappings, but will have more space available in the mbuf structure.')
option('mbuf_refcnt_atomic', type: 'boolean', value: true, description:
       'Atomically access the mbuf refcnt.')
option('platform', type: 'string', value: 'native', description:
       'Platform to build, either "native", "generic" or a SoC. Please refer to the Linux build guide for more information.')
option('pkt_mbuf_headroom', type: 'integer', value: 128, description:
       'Default data offset (in bytes) in a packet buffer to leave room for additional headers.')
option('enable_stdatomic', type: 'boolean', value: false, description:
       'enable use of C11 stdatomic')
option('enable_trace_fp', type: 'boolean', value: false, description:
       'enable fast path trace points.')
option('tests', type: 'boolean', value: true, description:
       'build unit tests')
option('use_hpet', type: 'boolean', value: false, description:
       'use HPET timer in EAL')

=== examples/fips_validation/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2018 Intel Corporation

# binary name
APP = fips_validation

# all source are stored in SRCS-y
SRCS-y := fips_validation.c
SRCS-y += fips_validation_aes.c
SRCS-y += fips_validation_hmac.c
SRCS-y += fips_validation_tdes.c
SRCS-y += fips_validation_gcm.c
SRCS-y += fips_validation_cmac.c
SRCS-y += fips_validation_ccm.c
SRCS-y += fips_validation_sha.c
SRCS-y += fips_dev_self_test.c
SRCS-y += fips_validation_xts.c
SRCS-y += fips_validation_rsa.c
SRCS-y += fips_validation_ecdsa.c
SRCS-y += fips_validation_eddsa.c
SRCS-y += main.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

JANSSON := $(shell $(PKGCONF) --exists jansson; echo $$?)
ifeq ($(JANSSON), 0)
LDFLAGS += $(shell $(PKGCONF) --libs jansson)
CFLAGS += -DUSE_JANSSON
endif

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/l3fwd/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2016 Intel Corporation

# binary name
APP = l3fwd

# all source are stored in SRCS-y
SRCS-y := main.c l3fwd_acl.c l3fwd_lpm.c l3fwd_fib.c l3fwd_em.c l3fwd_event.c
SRCS-y += l3fwd_event_generic.c l3fwd_event_internal_port.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
# Added for 'rte_eth_link_to_str()'
CFLAGS += -DALLOW_EXPERIMENTAL_API
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -I../common

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/qos_sched/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = qos_sched

# all source are stored in SRCS-y
SRCS-y := main.c args.c init.c app_thread.c cfg_file.c cmdline.c stats.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/server_node_efd/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2016-2020 Intel Corporation

subdirs := efd_node efd_server

.PHONY: all static shared clean $(subdirs)
all static shared clean: $(subdirs)

$(subdirs):
	$(MAKE) -C $@ $(MAKECMDGOALS)

=== examples/vhost/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = dpdk-vhost

# all source are stored in SRCS-y
SRCS-y := main.c virtio_net.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

LDFLAGS += -pthread

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/multi_process/client_server_mp/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2020 Intel Corporation

subdirs := mp_client mp_server

.PHONY: all static shared clean $(subdirs)
all static shared clean: $(subdirs)

$(subdirs):
	$(MAKE) -C $@ $(MAKECMDGOALS)

=== examples/multi_process/hotplug_mp/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = hotplug_mp

# all source are stored in SRCS-y
SRCS-y := main.c commands.c
SRC-DEPS := build/commands.h

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk) -I build/
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

build/commands.h: commands.list Makefile
	dpdk-cmdline-gen.py -o $@ --context-name=main_ctx $<

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build $(SRC-DEPS)
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build  $(SRC-DEPS)
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared build/*.h
	test -d build && rmdir -p build || true

=== examples/multi_process/client_server_mp/mp_client/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = mp_client

# all source are stored in SRCS-y
SRCS-y := client.c

CFLAGS += -I../shared

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== drivers/net/bnxt/hcapi/cfa_v3/CMakeLists.txt ===
#
# Copyright(c) 2019-2021 Broadcom Limited, all rights reserved
# Contains proprietary and confidential information.
#
# This source file is the property of Broadcom Limited, and
# may not be copied or distributed in any isomorphic form without
# the prior written consent of Broadcom Limited.
#

# Needed for compilation with chip-specific regdef.h
add_definitions(-DFIRMWARE_VIEW=1)

# Platform specific defines
if (cfa_p70)
    add_definitions(-DSUPPORT_CFA_HW_P70=1)
    set(PXX_FOLDER p70)
    set (tsm_needed 1)
    set (mm_needed 1)
endif ()

if (cfa_p80)
    add_definitions(-DSUPPORT_CFA_HW_P80=1)
    set(PXX_FOLDER p80)
    set (tcm_needed 1)
endif ()

# Reset Doc dir variables
set(CFA_API_DOC_DIRS "" CACHE INTERNAL "")
set(CFA_DESIGN_DOC_DIRS "" CACHE INTERNAL "")
set(CFA_UT_DOC_DIRS "" CACHE INTERNAL "")

# Include sub directories

if (idm_needed)
    add_subdirectory(idm)
    set(idm_libs cfa-idm-lib cfa-idm-lib-ut)
endif ()

if (tbm_needed)
    add_subdirectory(tbm)
    set(tbm_libs cfa-tbm-lib cfa-tbm-lib-ut)
endif ()

if (gim_needed)
    add_subdirectory(gim)
    set(gim_libs cfa-gim-lib cfa-gim-lib-ut)
endif ()

if (mm_needed)
    add_subdirectory(mm)
    set(mm_libs cfa-mm-lib cfa-mm-lib-ut)
endif ()

if (tsm_needed)
    add_subdirectory(tpm)
    add_subdirectory(tim)
    set(cfa-tim-lib cfa-tim-lib-ut cfa-tpm-lib cfa-tpm-lib-ut)
endif ()

if (tcm_needed)
    add_subdirectory(tcm)
    set(tcm_libs cfa-tcm-lib cfa-tcm-lib-ut)
endif ()

if (rdm_needed)
    add_subdirectory(rdm)
    set(rdm_libs cfa-rdm-lib cfa-rdm-lib-ut)
endif ()

# Update Doxygen dirs for api documentation
#set(CFA_API_DOC_DIRS ${CFA_API_DOC_DIRS}
#    ${CMAKE_CURRENT_SOURCE_DIR}/include
#    CACHE INTERNAL "")

# Update Doxygen dirs for design documentation
#set(CFA_DESIGN_DOC_DIRS ${CFA_DESIGN_DOC_DIRS}
#    ${CMAKE_CURRENT_SOURCE_DIR}/include
#    CACHE INTERNAL "")

# Include docs
#if (DOXYGEN_FOUND)
#    add_subdirectory(docs)
#    add_custom_target(cfa-v3-docs
#        DEPENDS hcapi-cfa-api-docs
#                hcapi-cfa-design-docs
#                hcapi-cfa-ut-docs
#        )
#endif (DOXYGEN_FOUND)

add_custom_target(cfa-v3-libs
    ALL
    DEPENDS ${tpm_libs} ${tim_libs} ${mm_libs})

=== drivers/net/bnxt/hcapi/cfa_v3/mm/CMakeLists.txt ===
#
# Copyright(c) 2021 Broadcom Limited, all rights reserved
# Contains proprietary and confidential information.
#
# This source file is the property of Broadcom Limited, and
# may not be copied or distributed in any isomorphic form without
# the prior written consent of Broadcom Limited.
#

add_library(cfa-mm-lib-common INTERFACE)
target_include_directories(cfa-mm-lib-common INTERFACE include
						../include
						../../include)

set (CFA_MM_SRCS cfa_mm.c)

# Production version
add_library(cfa-mm-lib STATIC EXCLUDE_FROM_ALL ${CFA_MM_SRCS})
set_property(TARGET cfa-mm-lib PROPERTY POSITION_INDEPENDENT_CODE 1)
target_link_libraries(cfa-mm-lib PUBLIC cfa-mm-lib-common nxt-platform nxt-arch)
target_include_directories(cfa-mm-lib PUBLIC ../include/platform/fw)

# UT version
add_library(cfa-mm-lib-ut STATIC EXCLUDE_FROM_ALL ${CFA_MM_SRCS})
set_property(TARGET cfa-mm-lib-ut PROPERTY POSITION_INDEPENDENT_CODE 1)
target_link_libraries(cfa-mm-lib-ut PUBLIC cfa-mm-lib-common nxt-ut nxt-platform nxt-arch nxt-env-ut)
target_include_directories(cfa-mm-lib-ut PUBLIC ../include/platform/ut)

set(ignoreMe "${SKIP_MM_UT}")
if(NOT DEFINED SKIP_MM_UT)
add_subdirectory(ut)
endif()

# Update Doxygen Path for mm api documentation
set(CFA_API_DOC_DIRS ${CFA_API_DOC_DIRS}
	${CMAKE_CURRENT_SOURCE_DIR}/include # Public api
	CACHE INTERNAL "")

# Update Doxygen Path for mm design documentation
set(CFA_DESIGN_DOC_DIRS ${CFA_DESIGN_DOC_DIRS}
	${CMAKE_CURRENT_SOURCE_DIR}         # mm implementation
	CACHE INTERNAL "")

=== drivers/net/bnxt/hcapi/cfa_v3/tim/CMakeLists.txt ===
#
# Copyright(c) 2021 Broadcom Limited, all rights reserved
# Contains proprietary and confidential information.
#
# This source file is the property of Broadcom Limited, and
# may not be copied or distributed in any isomorphic form without
# the prior written consent of Broadcom Limited.
#

add_library(cfa-tim-lib-common INTERFACE)
target_include_directories(cfa-tim-lib-common INTERFACE include
						../include
						../../include
						../../../tf_core)

set (CFA_TIM_SRCS cfa_tim.c)

# Production version
add_library(cfa-tim-lib STATIC EXCLUDE_FROM_ALL ${CFA_TIM_SRCS})
set_property(TARGET cfa-tim-lib PROPERTY POSITION_INDEPENDENT_CODE 1)
target_link_libraries(cfa-tim-lib PUBLIC cfa-tim-lib-common nxt-platform nxt-arch)
target_include_directories(cfa-tim-lib PUBLIC ../include/platform/fw)

# UT version
add_library(cfa-tim-lib-ut STATIC EXCLUDE_FROM_ALL ${CFA_TIM_SRCS})
set_property(TARGET cfa-tim-lib-ut PROPERTY POSITION_INDEPENDENT_CODE 1)
target_link_libraries(cfa-tim-lib-ut PUBLIC  cfa-tim-lib-common nxt-ut nxt-platform nxt-arch nxt-env-ut)
target_include_directories(cfa-tim-lib-ut PUBLIC ../include/platform/ut)

set(ignoreMe "${SKIP_TIM_UT}")
if(NOT DEFINED SKIP_TIM_UT)
add_subdirectory(ut)
endif()

# Update Doxygen Path for tim api documentation
set(CFA_API_DOC_DIRS ${CFA_API_DOC_DIRS}
	${CMAKE_CURRENT_SOURCE_DIR}/include # Public api
	CACHE INTERNAL "")

# Update Doxygen Path for tim design documentation
set(CFA_DESIGN_DOC_DIRS ${CFA_DESIGN_DOC_DIRS}
	${CMAKE_CURRENT_SOURCE_DIR}         # tim implementation
	CACHE INTERNAL "")

=== debian/changelog ===
dpdk (24.11.3-2) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * d/control: librte-net-ntnic25 is x86_64 only
  * d/control: librte-net-zxdh25 is x86_64 and arm64 only
  * d/p/disable_arm64_autopkgtest_fails.patch: disable tests that are
    flaky in debci (Closes: #1114911)

 -- Luca Boccassi <bluca@debian.org>  Wed, 24 Sep 2025 10:26:56 +0100

dpdk (24.11.3-1) unstable; urgency=medium

  * New upstream release 24.11.3. For a full list of changes in 24.11.3 see:
    https://doc.dpdk.org/guides/rel_notes/release_24_11.html

 -- Luca Boccassi <bluca@debian.org>  Tue, 19 Aug 2025 23:31:35 +0100

dpdk (24.11.2-2) unstable; urgency=medium

  * d/control: bump Standards-Version to 4.7.2, no changes
  * dpdk-doc: drop HTML documents
  * dpdk-doc: ship only public APIs manpages

 -- Luca Boccassi <bluca@debian.org>  Mon, 28 Apr 2025 14:09:40 +0100

dpdk (24.11.2-1) unstable; urgency=medium

  * Backport patch to add install_tag to meson for doc
  * Backport patch to fix installation directory of docs
  * dpdk-doc: use meson install --tags to streamline installation
  * d/rules: use execute_before/after
  * d/rules: drop dh_missing override
  * d/rules: use dh-sequence-python3 instead of --with python3
  * dpdk-doc: delete unreproducible javascript file
  * dpdk-doc: drop python3:Recommends
  * Drop build-dependencies for docs that are no longer needed
  * New upstream release 24.11.2. For a full list of changes in 24.11.2 see:
    https://doc.dpdk.org/guides/rel_notes/release_24_11.html

 -- Luca Boccassi <bluca@debian.org>  Wed, 23 Apr 2025 12:29:39 +0100

=== debian/control ===
Source: dpdk
Priority: optional
Maintainer: Debian DPDK Maintainers <pkg-dpdk-devel@lists.alioth.debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>,
           Christian Ehrhardt <christian.ehrhardt@canonical.com>,
           Santiago Ruano Rincón <santiagorr@riseup.net>,
Build-Depends: chrpath,
               debhelper-compat (= 13),
               dh-package-notes,
               dh-python,
               dh-sequence-python3,
               libbpf-dev,
               libbsd-dev,
               libelf-dev,
               libfdt-dev,
               libibverbs-dev (>= 23~),
               libipsec-mb-dev [amd64],
               libisal-dev [amd64],
               libjansson-dev,
               libmnl-dev,
               libnuma-dev,
               libpcap-dev,
               libssl-dev,
               libxdp-dev,
               meson (>= 0.47.1~),
               pkgconf,
               python3:any,
               python3-pyelftools,
               zlib1g-dev,
Build-Depends-Indep:
               doxygen <!nodoc>,
               python3-sphinx <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Section: libs
Homepage: https://www.dpdk.org
Vcs-Git: https://salsa.debian.org/debian/dpdk.git -b unstable
Vcs-Browser: https://salsa.debian.org/debian/dpdk

Package: dpdk
Section: admin
Architecture: amd64 arm64 ppc64el riscv64 loong64
Depends: pci.ids | hwdata,
         pciutils,
         procps,
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
         ${python3:Depends},
# Recommend a subset of more tested, more used and more supported libs
Recommends: librte-mempool25,
            librte-mempool-ring25,
            librte-net-af-packet25,
            librte-net-bond25,
            librte-net-e1000-25,
            librte-net-fm10k25,
            librte-net-i40e25,
            librte-net-ixgbe25,
            librte-net-mlx4-25,
            librte-net-mlx5-25,
            librte-net-netvsc25,
            librte-net-pcap25,
            librte-net-tap25,
            librte-net-thunderx25,
            librte-net-vdev-netvsc25,
            librte-net-vhost25,
            librte-net-virtio25,
            librte-net-vmxnet3-25,
            python3-pyelftools,
Suggests: dpdk-doc,
          dpdk-kmods-dkms,
          librte-meta-baseband,
          librte-meta-bus,
          librte-meta-common,
          librte-meta-compress,
          librte-meta-crypto,
          librte-meta-dma,
          librte-meta-event,
          librte-meta-mempool,
          librte-meta-net,
          librte-meta-raw,
          librte-meta-allpmds,
Breaks: dpdk-dev (<< 24.11~rc1-1),
Replaces: dpdk-dev (<< 24.11~rc1-1),
Description: Data Plane Development Kit (runtime)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime environment to run DPDK applications.

Package: librte-meta-baseband
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Baseband},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (baseband libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte baseband libraries.

Package: librte-meta-bus
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Bus},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (bus libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte bus libraries.

Package: librte-meta-common
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Common},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (common libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte common libraries.

Package: librte-meta-compress
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Compress},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (compress libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte compress libraries.

Package: librte-meta-crypto
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Crypto},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (crypto libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte crypto libraries.

Package: librte-meta-dma
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Dma},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (dma libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte dma libraries.

Package: librte-meta-event
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Event},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (event libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte event libraries.

Package: librte-meta-mempool
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Mempool},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (mempool libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte mempool libraries.

Package: librte-meta-net
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Net},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (net libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte net libraries.

Package: librte-meta-raw
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Raw},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (raw libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte raw libraries.

Package: librte-meta-allpmds
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Allpmds},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (all poll mode drivers)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all poll mode drivers produced by DPDK.

Package: librte-meta-all
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:All},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (all sub-libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all librte libraries produced by DPDK.

Package: dpdk-dev
Section: oldlibs
Architecture: amd64 arm64 ppc64el riscv64 loong64
Breaks: dpdk (<< 24.11~rc1-1),
Depends: libdpdk-dev (>= ${source:Version}),
         python3,
         ${misc:Depends},
         ${shlibs:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (dev tools)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains tools useful to a developer and for dpdk self tests.

Package: dpdk-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Homepage: https://dpdk.org/doc/guides/index.html
Depends: fonts-font-awesome,
         fonts-lato,
         fonts-roboto-slab,
         libjs-jquery,
         libjs-underscore,
         python3:any,
         ${misc:Depends},
         ${python3:Depends},
Description: Data Plane Development Kit (documentation)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the complete set of documentation and guides.

Package: libdpdk-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: libbpf-dev,
         libbsd-dev,
         libibverbs-dev,
         libipsec-mb-dev [amd64],
         libisal-dev [amd64],
         libelf-dev,
         libfdt-dev,
         libjansson-dev,
         libmnl-dev,
         libnuma-dev,
         libpcap-dev,
         libssl-dev,
         libxdp-dev,
         zlib1g-dev,
         ${librte:All},
         ${misc:Depends},
Description: Data Plane Development Kit (basic development files)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the basic headers and library files required to
 build external applications which will also require at least SSE3 support
 when running.
 .
 libdpdk.pc: note that CFLAGS might contain an -march flag higher than typical
 baseline.
 This is required for a number of static inline functions in the public headers.

Package: librte-acl25
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Homepage: https://dpdk.org/doc/api/rte__acl_8h.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
         ${shlibs:Depends},
Description: Data Plane Development Kit (librte-acl runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte-acl.

Package: librte-argparse25
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Homepage: https://doc.dpdk.org/guides/prog_guide/argparse_lib.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all
DEB_CFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
DEB_CXXFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
DEB_LDFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

# Upstream now defines a single ABI across all libs that we will use
DPDK_ABI := $(shell cat ABI_VERSION | cut -d. -f1)
# Experimental libs will have 0.200 on actual ABI 20.0
DPDK_EXP_ABI := "0.$(shell cat ABI_VERSION | cut -d. -f1-2 | tr -d ".")"

#ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
#	export DH_VERBOSE=1
#	export DH_OPTIONS=-v
#endif

# People rebuilding this package can overwrite RTE_PLATFORM
# via DEB_BUILD_OPTIONS if they like
ifneq (,$(filter rte_machine=%,$(DEB_BUILD_OPTIONS)))
	echo "WARNING: the machine setting is deprecated, please use platform (rte_platform)"
    RTE_PLATFORM ?= $(patsubst rte_machine=%,%,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
endif
ifneq (,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
    RTE_PLATFORM ?= $(patsubst rte_platform=%,%,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
endif
# default to minimal base, without setting this it would build
# -march=native which is a non portable invariant
RTE_PLATFORM ?= "generic"

ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
BUILD_DOCS=n
else
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
BUILD_DOCS=n
# to stop dh_installdoc from running
export DEB_BUILD_PROFILES += nodoc
else
BUILD_DOCS=y
endif
endif

# Allow to pass specific configure flags to meson as a comma separated list
ifneq (,$(filter dpdk_config_options=%,$(DEB_BUILD_OPTIONS)))
# GNU Makefile hack: can't directly escape comma and spaces, so use variables
    comma := ,
    empty :=
    space := $(empty) $(empty)
    DPDK_CONFIG_OPTIONS ?= $(subst $(comma),$(space),$(patsubst dpdk_config_options=%,%,$(filter dpdk_config_options=%,$(DEB_BUILD_OPTIONS))))
endif

%:
	dh $@ --buildsystem=meson

execute_after_dh_gencontrol:
	# debian/files will not exist until dh_gencontrol has ran at least once,
	# so we need to run gencontrol for libdpdk-dev after.
	# The list of libraries and PMDs is everchanging, so generate the dependency
	# list for libdpdk-dev to avoid having to maintain it manually.
	# Various meta packages help users to gain a granular access per lib-subtype.
	# The recommends list for dpdk has more common libs, all full meta categories
	# are listed as suggests.
	dh_gencontrol -p libdpdk-dev          -- -V"librte:All=`grep      -E 'librte-*'           ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-all      -- -V"librte:All=`grep      -E 'librte-*'           ./debian/files | grep -v dbgsym | grep -v 'librte-meta-' | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-baseband -- -V"librte:Baseband=`grep -E 'librte-baseband-.*' ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-bus      -- -V"librte:Bus=`grep      -E 'librte-bus-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-common   -- -V"librte:Common=`grep   -E 'librte-common-.*'   ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-compress -- -V"librte:Compress=`grep -E 'librte-compress-.*' ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-crypto   -- -V"librte:Crypto=`grep   -E 'librte-crypto-.*'   ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-dma      -- -V"librte:Dma=`grep      -E 'librte-dma-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-event    -- -V"librte:Event=`grep    -E 'librte-event-.*'    ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-mempool  -- -V"librte:Mempool=`grep  -E 'librte-mempool-.*'  ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-net      -- -V"librte:Net=`grep      -E 'librte-net-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-raw      -- -V"librte:Raw=`grep      -E 'librte-raw-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-allpmds -- -V"librte:Allpmds=`for pmd in $$(find -type d -wholename './debian/librte-*dpdk/pmds-*'); do awk -v "ver=$(DEB_VERSION)" '/^Package:/ {printf("%s (= %s), \n",$$2,ver)}' "$${pmd}/../../../../../DEBIAN/control"; done | LC_ALL=C sort --stable | xargs`"

execute_before_dh_auto_clean:
	rm -f doc/guides/compressdevs/overview_feature_table.txt \
		doc/guides/cryptodevs/overview_aead_table.txt \
		doc/guides/cryptodevs/overview_asym_table.txt \
		doc/guides/cryptodevs/overview_auth_table.txt \
		doc/guides/cryptodevs/overview_cipher_table.txt \
		doc/guides/cryptodevs/overview_feature_table.txt \
		doc/guides/nics/overview_table.txt \
		doc/guides/bbdevs/overview_feature_table.txt \
		doc/guides/cryptodevs/overview_os_table.txt \
		doc/guides/eventdevs/overview_crypto_adptr_feature_table.txt \
		doc/guides/eventdevs/overview_feature_table.txt \
		doc/guides/eventdevs/overview_rx_adptr_feature_table.txt \
		doc/guides/eventdevs/overview_timer_adptr_feature_table.txt \
		doc/guides/eventdevs/overview_tx_adptr_feature_table.txt \
		doc/guides/gpus/overview_feature_table.txt \
		doc/guides/nics/rte_flow_actions_table.txt \
		doc/guides/nics/rte_flow_items_table.txt \
		doc/guides/regexdevs/overview_feature_table.txt \
		doc/guides/vdpadevs/overview_feature_table.txt
	# test directory for sockets, etc
	rm -rf $(CURDIR)/tmpdir
	# every PMD package has a ldconfig-escape lintian warning, so we generate an override, delete them on cleanup
	find debian -type f \( -iname "librte-*.lintian-overrides" ! -iname "librte-meta*.lintian-overrides" \) -delete
	# some python helpers got precompiled in place along the way and are not always cleaned up
	find . -name '*.pyc' -type f -delete
	find . -name '__pycache__' -type d -delete

override_dh_auto_configure-indep:
	dh_auto_configure -- -Denable_docs=true

override_dh_auto_build-indep:
ifeq (y,$(BUILD_DOCS))
	dh_auto_build -- doc
endif

override_dh_auto_install-indep:
ifeq (y,$(BUILD_DOCS))
	# TODO: in compat 14 we can use dh_auto_install -- --no-rebuild --tags doc
	meson install -C obj-$(DEB_HOST_GNU_TYPE) --no-rebuild --tags doc --destdir ../debian/tmp/
endif

override_dh_auto_configure-arch:
	dh_auto_configure -- $(DPDK_CONFIG_OPTIONS) \
		--includedir=include/dpdk \
		--default-library=shared \
		-Dinclude_subdir_arch=../$(DEB_HOST_MULTIARCH)/dpdk \
		-Dplatform=$(RTE_PLATFORM) \
		-Db_lto=true
	head obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json || find . -name compile_commands.json
	grep --max-count=1 -e '-mcpu=' -e '-march=' \

=== debian/tests/control ===
Tests: test-initscripts
Restrictions: allow-stderr, isolation-machine, needs-root, skippable, skip-not-installable
Depends: dpdk, gawk, mount, systemd, sysvinit-utils, iproute2
Architecture: amd64 arm64 ppc64el riscv64

Tests: test-linkage
Restrictions: allow-stderr, skippable, skip-not-installable
Depends: libdpdk-dev, libc6-dev, gcc, grep, libpcap-dev, pax-utils, pkg-config
Architecture: amd64 arm64 ppc64el riscv64

Tests: test-autotest
Restrictions: allow-stderr, isolation-machine, needs-root, skippable, skip-not-installable
Depends: dpdk-dev [amd64 arm64 ppc64el riscv64], jq, python3, python3-pexpect

Tests: test-fastsuite
Restrictions: allow-stderr, skippable
Depends: build-essential, jq, @builddeps@
Architecture: amd64 arm64 ppc64el riscv64

=== debian/watch ===
version=4
https://fast.dpdk.org/rel/dpdk-(24.11.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## dpdk 24.11.4

=== debian/changelog ===
dpdk (24.11.4-0+deb13u1) trixie; urgency=medium

  [ Christian Ehrhardt ]
  * d/p/disable_arm64_autopkgtest_fails.patch: disable tests that are
    flaky in debci (Closes: #1114911)

  [ Luca Boccassi ]
  * New upstream release 24.11.4. For a full list of changes in 24.11.4 see:
    https://doc.dpdk.org/guides/rel_notes/release_24_11.html

 -- Luca Boccassi <bluca@debian.org>  Wed, 24 Dec 2025 14:21:11 +0000

dpdk (24.11.3-1~deb13u1) trixie; urgency=medium

  * Upload to trixie

 -- Luca Boccassi <bluca@debian.org>  Mon, 25 Aug 2025 16:13:59 +0100
